/***************************************************************************
                          ezserver.h  -  description                              
                             -------------------                                         
    begin                : Fri Aug 20 1999                                           
    copyright            : (C) 1999 by Joe Nelson                         
    email                : 3nelsons@pressenter.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef EasySERVER_H
#define EasySERVER_H

#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include <unistd.h>
#include "easyaddress.h"
#include "easyneterror.h"
#include "easysocket.h"

/**A socket server that accepts connections and hands them off to clients.
 * @author Joe Nelson
 */

class EasyServer {
public:
	EasyServer(unsigned short port) throw(EasyNetError);

	/** Returns the local address that the server is listening on.*/
	EasyAddress WhoAmI() const throw ();

	/** Wait for, and return, client connection */
	EasySocket AwaitConnection() throw(EasyNetError);
	
	~EasyServer() throw();

private:
	int _onPort;
	EasyAddress *_myAddress;
};

#endif
